;;****************************************************************
;;****************************************************************
;;****************************************************************
;;************************PWCsound 1.0***************
;;************************Giorgio Zucco (2013)**************
;;****************************************************************
;;****************************************************************
;;****************************************************************
;;****************************************************************
;
;;;       PWCsound for PWGL

;;; Copyright (c) 2013, Giorgio Zucco.  All rights reserved.

;;; Redistribution and use in source and binary forms, with or without
;;; modification, are permitted provided that the following conditions
;;; are met:

;;;   * Redistributions of source code must retain the above copyright
;;;     notice, this list of conditions and the following disclaimer.

;;;   * Redistributions in binary form must reproduce the above
;;;     copyright notice, this list of conditions and the following
;;;     disclaimer in the documentation and/or other materials
;;;     provided with the distribution.

;;; THIS SOFTWARE IS PROVIDED BY THE AUTHOR 'AS IS' AND ANY EXPRESSED
;;; OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
;;; WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
;;; ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
;;; DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
;;; DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
;;; GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
;;; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
;;; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
;;; NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;;; SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


(in-package :PWCSOUND)

;;Tools

;;run csound compiler
(PWGLDef real-time ( (filename (concatenate 'string '(#\") "/test.csd" '(#\"))) (flag (concatenate 'string '(#\") "-odac" '(#\"))) )
"run csound compiler"
(:class 'ccl::PWGL-values-box :outputs 1 :r 0.498039 :g 1 :b 0.831373 :w 0.5 :groupings '(2) )
(sys:call-system-showing-output (list "/usr/local/bin/csound"  flag  filename ) :wait t) )

;;run csound compiler
(PWGLDef write-to-disk ( (filename "test.csd") )
"run csound compiler"
(:class 'ccl::PWGL-values-box :outputs 1 :r 0.498039 :g 1 :b 0.831373 :w 0.5 :groupings '(1) )
(sys:call-system-showing-output (list "/usr/local/bin/csound" "-A" filename ) :wait t) )


;; SCRIVI ORCHESTRA FILE
(PWGLDef make-csd ((data "csd") (filename (concatenate 'string '(#\") "/test.csd" '(#\"))) ) 
"Csd"
(:class 'ccl::PWGL-values-box :outputs 1 :r 0.498039 :g 1 :b 0.831373 :w 0.6 :groupings '(1 1) )  
(list data  filename )

(with-open-file (stream filename
                        :direction :output
                        :if-does-not-exist :create
                        :if-exists :supersede)
(dolist (x (list (pw::flat  data  )))

(let ((*print-case* :downcase))

(format stream  "~{~A ~}~%" x )) data   )))




(PWGLDef synthesize ((data "csd") (filename (concatenate 'string '(#\") "/test.csd" '(#\"))) (flag (concatenate 'string '(#\") "-odac" '(#\"))) ) 
"render csd"
(:class 'ccl::PWGL-values-box :outputs 1 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :w 0.4 :groupings '(1 1 1) )  
(list data  filename )

(with-open-file (stream filename
                        :direction :output
                        :if-does-not-exist :create
                        :if-exists :supersede)
(dolist (x (list (pw::flat  data  )))

(let ((*print-case* :downcase))

(format stream  "~{~A ~}~%" x )) data   ))
(sys:call-system-showing-output (list "/usr/local/bin/csound"  flag  filename ) :wait t) )



;;instr
(PWGLdef instr (  (number "1") )
""
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(t2 (remove nil (pw::list  "instr" #\Space number  #\return )) )
)
(values t2  )))


(PWGLdef endin (  (endin "endin") )
"Sets the global seed value."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(t2 (remove nil (pw::list  endin  #\return )) )
)
(values t2  )))


;;GLOBAL FX

(PWGLdef cs-append (  (global-fx1 ())  (global-fx2 ()) (orchestra ()) )
"orchestra with master stereo global fx"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.5 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 1 1 )) 
(let* 
( 
(ad1 (remove nil (pw::list   global-fx1 #\return #\linefeed global-fx2 #\return #\linefeed orchestra #\return #\linefeed)) )
)
(values ad1 )))


;;init global fx

(PWGLdef  init ( (a () (ccl::mk-menu-subview :menu-list 
'(
"garev"
"gadelay"
"gafx1"
"gafx2"
"gafx3"
"gafx4"
"gafx5"
"gafx6"
"gafx7"
"gafx8"

 ) :value 1))) 
"global init fx"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(t1 (remove nil (pw::list a #\Space  "init" #\Space "0"  ))) 
)
(values t1 ))) 



(PWGLdef  vincr ( (a () (ccl::mk-menu-subview :menu-list 
'(
"garev"
"gadelay"
"gafx1"
"gafx2"
"gafx3"
"gafx4"
"gafx5"
"gafx6"
"gafx7"
"gafx8"
 ) :value 1))) 
"vincr"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(t1 (remove nil (pw::list  "vincr(" a "," "asig" ")" #\return #\linefeed ))) 
)
(values t1 ))) 




(PWGLdef  vincr-stereo ( (a () (ccl::mk-menu-subview :menu-list 
'(
"garev"
"gadelay"
"gafx1"
"gafx2"
"gafx3"
"gafx4"
"gafx5"
"gafx6"
"gafx7"
"gafx8"
 ) :value 1))) 
"vincr"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(t1 (remove nil (pw::list  "vincr(" a "," "asig1" ")" #\return #\linefeed "vincr(" a "," "asig2" ")" #\return #\linefeed ))) 
)
(values t1 ))) 


(PWGLdef  clear ( (a () (ccl::mk-menu-subview :menu-list 
'(
"garev"
"gadelay"
"gafx1"
"gafx2"
"gafx3"
"gafx4"
"gafx5"
"gafx6"
"gafx7"
"gafx8"
 ) :value 1))) 
"vincr"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(t1 (remove nil (pw::list  "clear(" a ")" ))) 
)
(values t1 ))) 



;;OUT-FX
(PWGLdef mono-fx ( (instr "1" ) (in "connect") (fx () ) &optional (envelope () ) (trigger () ) )
"mono
output  : out asig"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.2 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2  )) 
(let* 
( 
(mixx2 (remove nil (pw::list trigger #\return "instr" instr #\return  #\linefeed "asig" "=" in #\return  #\linefeed "out" "asig"
 envelope #\return #\linefeed fx   #\return #\linefeed "endin" #\return #\linefeed  ))) 
) 
(values mixx2  ))) 


(PWGLdef stereo-fx ( (instr "1" ) (in1 "in1")  (in2 "in2") (fx ()) &optional (envelope () ) (trigger () ) )
"mono
output  : outs asig,asig"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 1 1 1 )) 
(let* 
( 
(mixx2 (remove nil (pw::list trigger #\return "instr" instr #\return  #\linefeed "asig1" "=" in1 #\return #\linefeed "asig2" "=" in2 #\return #\linefeed "outs" 
"asig1"  envelope ","  "asig2"  envelope #\return #\linefeed fx   #\return #\linefeed  "endin" #\return #\linefeed  ))) 
) 
(values mixx2  ))) 

;;Make csd
(PWGLDef orc-sco ( (sr "44100" ) (ksmps "1") (channels "1") (orchestra "orchestra") (score "score") )
"Connect orchestra-score"
(:r 0.498039 :g 1 :b 0.831373 :groupings '(1 1 1 1 1 )) 
(list  "<CsoundSynthesizer>" #\return "<CsOptions>" #\return "</CsOptions>" #\return "<CsInstruments>" #\return "sr=" sr #\return   "ksmps=" ksmps #\return  "nchnls" "=" channels #\return "0dbfs=1" #\return #\linefeed "#include" (concatenate 'string '(#\") "pwcs" '(#\\) "pwcsound.inc" '(#\"))    #\return #\linefeed orchestra "</CsInstruments>" #\return "<CsScore>"  #\return #\return #\linefeed score #\return #\linefeed "</CsScore>" #\return "</CsoundSynthesizer>" #\return))

 
(PWGLDef orc-sco-disk ( (flag () ) (sr "44100" ) (ksmps "1") (channels "2") (orchestra "orchestra") (score "score") (recording ()) (rec-time "10") )
"Connect orchestra (stereo!),score, stereo disk recording input"
(:r 0.498039 :g 1 :b 0.831373 :groupings '(1 1 1 1 1 1 1 1)) 
(list  "<CsoundSynthesizer>" #\return "<CsOptions>" #\return flag #\return "</CsOptions>" #\return "<CsInstruments>" #\return "sr=" sr #\return   "ksmps=" ksmps #\return  "nchnls" "=" channels #\return "0dbfs=1" #\return #\linefeed "#include" (concatenate 'string '(#\") "pwcs" '(#\\) "pwcsound.inc" '(#\"))  #\return #\linefeed orchestra
#\return #\linefeed recording #\return 
 "</CsInstruments>" #\return "<CsScore>"  #\return #\return #\linefeed score #\return #\linefeed  "i9999" "0" rec-time #\return #\linefeed "</CsScore>" #\return "</CsoundSynthesizer>" #\return))


(PWGLDef record-to-disk ( (filename () ) (iformat "1")  )
"fout opcode, stereo disk recording"
(:r 0.498039 :g 1 :b 0.831373 :groupings '(1 1 )) 
(list  "instr" #\Space "9999" #\return "a1,a2" #\Space "monitor" #\return 
 
"fout" #\Space (concatenate 'string '(#\") filename '(#\")) "," iformat ",a1,a2" #\return "endin" #\return #\linefeed 
))


;;OUT
(PWGLdef mono ( (instr "1" ) (in "connect")  &optional (envelope () ) (trigger () ) )
"mono
output  : out asig"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.2 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2  )) 
(let* 
( 
(mixx2 (remove nil (pw::list trigger #\return "instr" instr #\return  #\linefeed "asig" "=" in #\return  #\linefeed "out" "asig"
 envelope #\return #\linefeed "endin" #\return #\linefeed  ))) 
) 
(values mixx2  ))) 



(PWGLdef stereo ( (instr "1" ) (in1 "in1")  (in2 "in2") &optional (envelope () ) (trigger () ) )
"mono
output  : outs asig,asig"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.2 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 1 1  )) 
(let* 
( 
(mixx2 (remove nil (pw::list trigger #\return "instr" instr #\return  #\linefeed "asig1" "=" in1 #\return #\linefeed "asig2" "=" in2 #\return #\linefeed "outs" 
"asig1"  envelope ","  "asig2"  envelope #\return #\linefeed "endin" #\return #\linefeed  ))) 
) 
(values mixx2  ))) 


(PWGLdef quad ( (instr "1" ) (in1 "in1")  (in2 "in2") (in3 "in3") (in4 "in4")  &optional (envelope () ) (trigger () ) )
"mono
output  : outq asig,asig,asig,asig"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.2 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2  )) 
(let* 
( 
(mixx2 (remove nil (pw::list trigger #\return "instr" instr #\return  #\linefeed "asig1" "=" in1 #\return #\linefeed "asig2" "=" in2 #\return #\linefeed "asig3" "=" in3 #\return #\linefeed "asig4" "=" in4 #\return #\linefeed "outq" 
"asig1"  envelope ","  "asig2"  envelope ","  "asig3"  envelope ","  "asig4"  envelope #\return #\linefeed "endin" #\return #\linefeed  ))) 
) 
(values mixx2  ))) 


;;audio input


(PWGLdef audio-input ( (in1 "input") )
"mono audio input"

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "in("  ")" )) )
) 
(values tone1  ))) 


;;*******************************
;;*******************************
;;*********SPAT************
;;*******************************
;;*******************************



(PWGLdef pan ( (in "connect") (pan ".5")  )
"autopan"
(:class 'ccl::PWGL-values-box :outputs 2  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list  in "*" pan )))
(tone2 (remove nil (pw::list  in "*" "(1-" pan ")" )))
) 
(values tone1 tone2 )))



;;pan2
(PWGLdef jspline-pan ( (in "connect") (min-rate "0.1")  (max-rate "10") )
"random spline stereo pan"
(:class 'ccl::PWGL-values-box :outputs 2  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list  in "*" "(1-jspline:k(1,"  min-rate "," max-rate "))"  )))
(tone2 (remove nil (pw::list  in "*" "jspline:k(1,"  min-rate "," max-rate ")"  )))
) 
(values tone1 tone2 )))


(PWGLdef autopan ( (in "connect") (rate "2")  )
"autopan"
(:class 'ccl::PWGL-values-box :outputs 2  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list  in "*" "(1-lfo:k(1," rate  "))"  )))
(tone2 (remove nil (pw::list  in "*" "lfo:k(1,"  rate ")"  )))
) 
(values tone1 tone2 )))




;;REVERBERATION



(PWGLdef platerev ( (in1 "connect") (kbndry "1") (iaspect "0.73") (istiff "1") (idecay "5") (iloss "0.001") )
"Models the reverberation of a rectangular metal plate with settable physical characteristics when excited by audio signal(s)."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 2) ) 
(let* 
( 
(tone1 (remove nil (pw::list "platerev:a(" "gipl1,gipl2" "," kbndry "," iaspect "," istiff "," idecay "," iloss "," in1 ")" )) )
) 
(values tone1  ))) 






(PWGLdef freeverb ( (in1 "connect") (in2 "connect") (kroomsize "0.9") (kdamp "0.35") (kdrywet ".5") )
"freeverb is a stereo reverb unit based on Jezar's public domain C++ sources, composed of eight parallel comb filters on both channels, followed by four allpass units in series. The filters on the right channel are slightly detuned compared to the left channel in order to create a stereo effect."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 1) ) 
(let* 
( 
(tone1 (remove nil (pw::list "freeverbx(" in1 "," in2 ","  kroomsize ","  kdamp  "," kdrywet ")" )) )
) 
(values tone1  ))) 




(PWGLdef reverbsc ( (in1 "connect") (in2 "connect") (kfback "0.85") (kcut "12000") (kdrywet ".5") )
"8 delay line stereo FDN reverb, with feedback matrix based upon physical modeling scattering junction of 8 lossless waveguides of equal characteristic impedance. Based on Csound orchestra version by Sean Costello."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 1) ) 
(let* 
( 
(tone1 (remove nil (pw::list "revsc(" in1 "," in2 ","  kfback ","  kcut  "," kdrywet ")" )) )
) 
(values tone1  ))) 





(PWGLdef alpass ( (in1 "connect") (krvt "3.5") (ilpt "0.1")  )
"Reverberates an input signal with a flat frequency response."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "alpass(" in1  ","  krvt ","  ilpt ")" )) )
) 
(values tone1  ))) 



(PWGLdef comb ( (in1 "connect") (krvt "3.5") (ilpt "0.1")  )
"Reverberates an input signal with a colored frequency response."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "comb(" in1  ","  krvt ","  ilpt ")" )) )
) 
(values tone1  ))) 

;;****************************************
;;****************************************
;;*************ENVELOPE***********************
;;****************************************




(PWGLdef adsr (  (iatt "0.05") (idec ".5") (isus "1") (irel ".2") )
"Calculates the classical ADSR envelope using linear segments."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "adsr:k(" iatt "," idec ","  isus ","  irel ")" )) )
) 
(values tone1  ))) 


(PWGLdef madsr (  (iatt "0.05") (idec ".5") (isus "1") (irel ".2") )
"Calculates the classical ADSR envelope using the linsegr mechanism."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "madsr:a(" iatt "," idec ","  isus ","  irel ")" )) )
) 
(values tone1  ))) 

(PWGLdef mxadsr (  (iatt "0.05") (idec ".5") (isus "1") (irel ".2") )
"Calculates the classical ADSR envelope using the expsegr mechanism."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "mxadsr:a(" iatt "," idec ","  isus ","  irel ")" )) )
) 
(values tone1  ))) 


(PWGLdef linseg-points (  (data "0") )
"linseg envelope"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.8 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "linseg:k(" data  ")" )) )
) 
(values tone1  ))) 



(PWGLdef linseg3 (  (point1 "0")  (point2 "1") (point3 "0") (dur "p3/2") )
"linseg envelope"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.6 :r 0.498039 :g 1 :b 0.831373 :groupings '( 4 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "linseg:k(" point1 ","  dur  ","  point2 "," dur "," point3 ")" )) )
) 
(values tone1  ))) 


(PWGLdef linseg4 (  (point1 "1")  (point2 ".5") (point3 "1") (point4 "0") (dur "p3/3") )
"linseg envelope"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.7 :r 0.498039 :g 1 :b 0.831373 :groupings '( 5 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "linseg:k(" point1 ","  dur  ","  point2 "," dur "," point3  "," dur "," point4 ")" )) )
) 
(values tone1  ))) 


(PWGLdef linseg5 (  (point1 "0")  (point2 "1") (point3 ".2") (point4 ".8") (point5 "0") (dur "p3/4") )
"linseg envelope"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.8 :r 0.498039 :g 1 :b 0.831373 :groupings '( 6 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "linseg:k(" point1 ","  dur  ","  point2 "," dur "," point3  "," dur "," point4 "," dur "," point5 ")" )) )
) 
(values tone1  ))) 


(PWGLdef linseg6 (  (point1 ".2")  (point2 "1") (point3 ".2") (point4 ".8") (point5 ".4") (point6 "0") (dur "p3/5") )
"linseg envelope"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.9 :r 0.498039 :g 1 :b 0.831373 :groupings '( 7 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "linseg:k(" point1 ","  dur  ","  point2 "," dur "," point3  "," dur "," point4 "," dur "," point5 "," dur "," point6 ")" )) )
) 
(values tone1  ))) 


(PWGLdef line (  (point1 "0") (dur "p3") (point2 "1") )
"envelope"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "line:k(" point1 ","  dur  ","  point2 ")" )) )
) 
(values tone1  ))) 


(PWGLdef linseg-pad ( (audio "linseg") )
"simple linseg envelope"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "linseg:k(" '("0,p3/2,1,p3/2,0)") ) ) )
) 
(values tone1  )))





(PWGLdef expon (  (point1 "0") (dur "p3") (point2 "1") )
"Trace an exponential curve between specified points"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "expon:k(" point1 ","  dur  ","  point2 ")" )) )
) 
(values tone1  ))) 



(PWGLdef jspline ( (kamp "8") (min "15") (max"10")   )
"A jitter-spline generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 ) ) 
(let* 
( 
(t2 (remove nil (pw::list  "jspline:k(" kamp "," min "," max ")"  )) )
)
(values t2  )))


(PWGLdef rspline ( (rangemin "10") (rangemax "40") (cpsmin "1") (cpsmax"4")   )
"Generate random spline curves."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 ) ) 
(let* 
( 
(t2 (remove nil (pw::list  "rspline:k(" rangemin "," rangemax "," cpsmin "," cpsmax ")"  )) )
)
(values t2  )))


(PWGLdef  declick ( (global "connect")  )
"declick."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1   ) ) 
(let* 
( (tone1 (remove nil (pw::list "declick(" global ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef env-poscil ( (iamp ".6") (ifn "p6"))
"poscil envelope for gen07"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "poscil(" iamp ",1/p3,"   ifn ")" #\\ #\return )) )
)
(values ad1 ))) 




(PWGLdef scale ( (in1 "connect") (kmin "0") (kmax "1")  )
"Scales incoming value to user-definable range. Similar to scale object found in popular dataflow languages."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "scale(" in1  ","  kmax ","  kmin ")" )) )
) 
(values tone1  ))) 




(PWGLdef logcurve ( (kindex "0") (ksteepness "1")  )
"This opcode implements a formula for generating a normalised logarithmic curve in range 0 - 1. It is based on the Max / MSP work of Eric Singer (c) 1994."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 1 )) 
(let* 
( 
(tone1 (remove nil (pw::list "logcurve(" kindex","  ksteepness ")" )) )
) 
(values tone1  )))



;;****************************************
;;****************************************
;;*************LFO,VIBRATO****************
;;****************************************
;;****************************************


;;UPDATE to CSOUND6
(PWGLdef  lfo (  (depth "2" )  (rate "2" ) (a () (ccl::mk-menu-subview :menu-list 
'(
"0;sine"
"1;triangles"
"2;square(bipolar)"
"3;square(unipolar)"
"4;saw"
"5;saw(down" 
) :value 1))) 
"lfo"

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 1 ) ) 
(let* 
( 
(t1 (remove nil (pw::list  "lfo:k(" depth "," rate "," a ")" ))) 
)
(values t1 ))) 



(PWGLdef vibr (  (depth "2") (rate "2") (ifn () ) )
"Easier-to-use user-controllable vibrato"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 1 ) ) 
(let* 
( 

(t2 (remove nil (pw::list "vibr:k(" depth "," rate "," ifn ")" )) )
)
(values t2  ))) 

;;****************************************
;;****************************************
;;*************FILTERS***********************
;;****************************************
;;****************************************

;;FILTRI



(PWGLdef  follow ( (global "connect") (idt "0.001" ) )
"Envelope follower unit generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "tone(" global "," idt ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  tone ( (global "connect") (freq "1000" ) (freqdev () ) )
"tone, a first-order recursive low-pass filter with variable frequency response
output : syntax (ares tone asig, kfreq)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "tone(" global "," freq  freqdev ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  atone ( (global "connect") (freq "1000" ) (freqdev () ) )
"A hi-pass filter whose transfer functions are the complements of the tone opcode."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "atone(" global "," freq  freqdev ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  areson ( (global "connect") (freq "1000" ) (band "100" ) (freqdev () ) )
"A notch filter whose transfer functions are the complements of the reson opcode."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "areson(" global "," freq  freqdev "," band ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  lowpass2 ( (global "connect") (freq "1000" ) (reso "30" ) (freqdev () ) )
"Implementation of a resonant second-order lowpass filter."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "lowpass2(" global "," freq  freqdev "," reso ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  lowresx ( (global "connect") (freq "1000" ) (reso "30" ) (layer "4" ) (freqdev () ) )
"Simulates layers of serially connected resonant lowpass filters."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "lowresx(" global "," freq  freqdev "," reso "," layer ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  lpf18 ( (global "connect") (freq "1000" ) (reso "30" ) (kdist "10000" ) (freqdev () ) )
"Implementation of a 3 pole sweepable resonant lowpass filter."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "lpf18(" global "," freq  freqdev "," reso "," kdist ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  lowres ( (global "connect") (freq "1000" ) (reso "30" ) (freqdev () ) )
"lowres is a resonant lowpass filter."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "lowres(" global "," freq  freqdev "," reso ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  moogvcf ( (global "connect") (freq "1000" ) (reso ".2" ) (freqdev () ) )
"A digital emulation of the Moog diode ladder filter configuration."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "moogvcf2(" global "," freq  freqdev "," reso ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  moogladder ( (global "connect") (freq "1000" ) (reso ".2" ) (freqdev () ) )
"Moogladder is an new digital implementation of the Moog ladder."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "moogladder(" global "," freq  freqdev "," reso ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  reson ( (global "connect") (freq "1000" ) (band "50" ) (freqdev () ) )
"A second-order resonant filter."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "reson(" global "," freq  freqdev "," band ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  resonx ( (global "connect") (freq "1000" ) (band "50" ) (freqdev () ) (layer "4" ) )
"Emulates a stack of filters using the reson opcode."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "resonx(" global "," freq  freqdev "," band "," layer ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  butterbp ( (global "connect") (freq "1000" ) (band "50" ) (freqdev () ) )
"Implementation of a second-order band-pass Butterworth filter."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "butterbp(" global "," freq  freqdev "," band ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  butterbr ( (global "connect") (freq "1000" ) (band "50" ) (freqdev () ) )
"Implementation of a second-order band-reject Butterworth filter."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "butterbr(" global "," freq  freqdev "," band ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  butterhp ( (global "connect") (freq "1000" ) (freqdev () ) )
"Implementation of second-order high-pass Butterworth filter."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "butterhp(" global "," freq  freqdev  ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  butterlp ( (global "connect") (freq "1000" ) (freqdev () ) )
"Implementation of second-order low-pass Butterworth filter."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "butterlp(" global "," freq  freqdev  ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  dcblock ( (global "connect") )
"Implements a DC blocking filter."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1  ) ) 
(let* 
( (tone1 (remove nil (pw::list "dcblock(" global ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  dcblock2 ( (global "connect") )
"Implements a DC blocking filter with improved DC attenuation."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1  ) ) 
(let* 
( (tone1 (remove nil (pw::list "dcblock2(" global ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  fofilter ( (global "connect") (freq "1000" ) (kris "0.007" ) (kdec "0.04" ) (freqdev () ) )
"Fofilter generates a stream of overlapping sinewave grains, when fed with a pulse train."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "fofilter(" global "," freq  freqdev "," kris "," kdec ")" #\\ #\return )) )) 
(values tone1 ))) 




;;****************************************
;;****************************************
;;*************EFFECTS***********************
;;****************************************
;;****************************************

(PWGLdef  freq-shift ( (global "connect") (freq "1000" ) (freqdev () ) )
"frequency shifting, or single sideband amplitude modulation. Frequency shifting is similar to ring modulation, except the upper and lower sidebands are separated into individual outputs"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "freqshift(" global "," freq  freqdev "," "gisine" ")" #\\ #\return )) )) 
(values tone1 )))

 

(PWGLdef  fbkdelay ( (global "connect") (kdelay ".5" ) (ifback ".5" ) )
"simple feedback delay"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "fbkdelay(" global "," kdelay "," ifback ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  delay1 ( (global "connect")  )
"Delays an input signal by one sample"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1   ) ) 
(let* 
( (tone1 (remove nil (pw::list "delay1(" global ")" #\\ #\return )) )) 
(values tone1 ))) 



(PWGLdef  delay ( (global "connect")  (del ".5" ) (dry-wet ".2" ) )
"simple delay"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "simpledelay(" global "," del "," dry-wet ")" #\\ #\return )) )) 
(values tone1 )))





(PWGLdef  vintage-echo ( (global "connect") (ilevel ".5" ) (del ".5" ) (kfilt "1000" ) )
"simple delay with feedback"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "vintagecho(" global "," ilevel "," del "," kfilt ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  vdelay ( (global "connect")  (adel "1" ) (imaxdel "100" )  )
"An interpolating variable time delay."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 1  ) ) 
(let* 
( (tone1 (remove nil (pw::list "vdelay(" global "," adel "," imaxdel  ")" #\\ #\return )) )) 
(values tone1 )))

(PWGLdef  vdelay3 ( (global "connect")  (adel "1" ) (imaxdel "100" )  )
"A variable time delay with cubic interpolation."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 1  ) ) 
(let* 
( (tone1 (remove nil (pw::list "vdelay3(" global "," adel "," imaxdel  ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  phaser ( (global "connect")  (mod "800" ) (rate ".3" ) (dry-wet ".5" ) )
"An implementation of iord number of second-order allpass filters in series."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "phaser2x(" global "," rate "," mod "," dry-wet ")" #\\ #\return )) )) 
(values tone1 )))
 

(PWGLdef  flanger ( (global "connect")  (depth "2" ) (rate "2" ) (feedback ".5" ) )
"A user controlled flanger."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "flangerx(" global "," depth "," rate "," feedback ")" #\\ #\return )) )) 
(values tone1 )))



(PWGLdef  doppler ( (global "connect")  (kposition "120") (kmicposition "4") (isoundspeed "340")  (ifiltercutoff "6") )
"A fast and robust method for approximating sound propagation, achieving convincing Doppler shifts without having to solve equations."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2 2 ) ) 
(let* 
( (tone1 (remove nil (pw::list "doppler(" global "," kposition "," kmicposition "," isoundspeed "," ifiltercutoff ")" #\\ #\return )) )) 
(values tone1 )))



(PWGLdef  chorus ( (global "connect")  (depth "1" ) (rate "2" )  )
"A user controlled chorus."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "chorus(" global "," depth "," rate  ")" #\\ #\return )) )) 
(values tone1 )))



(PWGLdef  metalizer ( (global "connect")  (depth "2" ) (rate "4" )  )
"A comb filters bank"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "metalizer(" global "," depth "," rate  ")" #\\ #\return )) )) 
(values tone1 )))

 


(PWGLdef rndphaser ( (global "connect")  (depth "2" ) (mod "16" )  )
"mono random phaser fx"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "rndphaser(" global "," depth "," mod  ")" #\\ #\return )) )) 
(values tone1 )))



(PWGLdef bitcrush ( (global "connect")  (bit "8" ) (srate "12000" )  )
"bit reduction"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "decimator(" global "," bit "," srate  ")" #\\ #\return )) )) 
(values tone1 )))

;;****************************************
;;****************************************
;;*************RANDOM***********************
;;****************************************
;;****************************************


(PWGLdef  jitter2  ( (ktotamp "10")  (kamp1 ".5") (kcps1 "10") (kamp2 ".5")  (kcps2 "2")  (kamp3 ".5") (kcps3 "3")   )
"Generates a segmented line with user-controllable random segments."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2 2 2 ) ) 
(let* 
( (tone1 (remove nil (pw::list "jitter2(" ktotamp "," kamp1 "," kcps1  "," kamp2  "," kcps2  ","  kamp3  "," kcps3 ")" #\\ #\return )) )) 
(values tone1 )))



(PWGLdef  weibull  ( (ksigma "1") (ktau "1")  )
"Weibull distribution random number generator (positive values only). This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "weibull:a(" krange ")" #\\ #\return )) )) 
(values tone1 )))

(PWGLdef  weibull-k  ( (ksigma "1") (ktau "1")  )
"Weibull distribution random number generator (positive values only). This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "weibull:k(" krange ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  unirand  ( (krange "1")   )
"Uniform distribution random number generator (positive values only). This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "unirand:a(" krange ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  unirand-k  ( (krange "1")   )
"Uniform distribution random number generator (positive values only). This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "unirand:k(" krange ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  rnd31  ( (kscl "1")  (krpow "0") (iseed "10") )
"31-bit bipolar random opcodes with controllable distribution. These units are portable, i.e. using the same seed value will generate the same random sequence on all systems. The distribution of generated random numbers can be varied at k-rate."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "rnd31:k(" kscl "," krpow "," iseed ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  poisson  ( (klambda "20")   )
"Poisson distribution random number generator (positive values only). This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "poisson:a(" klambda ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  poisson-k  ( (klambda "20")   )
"Poisson distribution random number generator (positive values only). This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "poisson:k(" klambda ")" #\\ #\return )) )) 
(values tone1 )))

(PWGLdef  pinkish  ( (xin "1") (imeth "1")  (inumbands "0")  (iseed "0") (iskip "1") )
"Generates approximate pink noise (-3dB/oct response) by one of two different methods."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2 2 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pinkish:a(" xin "," imeth "," inumbands "," iseed "," iskip ")" #\\ #\return )) )) 
(values tone1 )))



(PWGLdef  gausstrig  ( (kamp "1") (kcps "2")  (kdev "1")  (imode "0")  )
"Generates random impulses around a certain frequency."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2 ) ) 
(let* 
( (tone1 (remove nil (pw::list "gausstrig:a(" kamp "," kcps "," kdev "," imode ")" #\\ #\return )) )) 
(values tone1 )))



(PWGLdef  gauss  ( (krange "1")   )
"Gaussian distribution random number generator. This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "gauss:a(" krange ")" #\\ #\return )) )) 
(values tone1 )))

(PWGLdef  gauss-k  ( (krange "1")   )
"Gaussian distribution random number generator. This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "gauss:k(" krange ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  exprand  ( (klambda "20")   )
"Exponential distribution random number generator (positive values only). This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "exprand:a(" klambda ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  exprand-k  ( (klambda "20")   )
"Exponential distribution random number generator (positive values only). This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "exprand:k(" klambda ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef cuserrnd ( (kmin "1")  (kmax "1" ) (ktable "1" )  )
"Continuous USER-defined-distribution RaNDom generator"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "cuserrnd:k(" kmin "," kmax "," ktable  ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef  cauchy ( (krange "100")   )
"Cauchy distribution random number generator. This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "cauchy:a(" krange ")" #\\ #\return )) )) 
(values tone1 )))

(PWGLdef  cauchy-k ( (krange "100")   )
"Cauchy distribution random number generator. This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "cauchy:k(" krange ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef bexprnd ( (krange "100")   )
"Exponential distribution random number generator. This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "bexprnd:a(" krange ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef betarand ( (krange "100")  (kalpha "1" ) (kbeta "1" )  )
"Beta distribution random number generator ,positive values only. This is an x-class noise generator"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "betarand:a(" krange "," kalpha "," kbeta  ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef bexprnd-k ( (krange "100")   )
"Exponential distribution random number generator. This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "bexprnd:k(" krange ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef betarand-k ( (krange "100")  (kalpha "1" ) (kbeta "1" )  )
"Beta distribution random number generator ,positive values only. This is an x-class noise generator"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "betarand:k(" krange "," kalpha "," kbeta  ")" #\\ #\return )) )) 
(values tone1 )))



(PWGLdef trandom ( (ktrig "1")  (kmin "1" ) (kmax "100" )  )
"Generates a controlled pseudo-random number series between min and max values at k-rate whenever the trigger parameter is different to 0"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "trandom(" krange "," kalpha "," kbeta  ")" #\\ #\return )) )) 
(values tone1 )))


(PWGLdef rnd ( (value "2")  )
"Returns a random number in a unipolar range at the rate given by the input argument."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1  ) ) 
(let* 
( (tone1 (remove nil (pw::list "rnd(" value  ")" #\\ #\return )) )) 
(values tone1 )))



(PWGLdef randomi ( (min "2") (max"200") (rate "1") (mode "0" ) )
"Generates a user-controlled random number series with interpolation between each new number."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 ) ) 
(let* 
( 

(t2 (remove nil (pw::list "randomi:k(" min "," max "," rate 
"," mode ")" )) )
)
(values  t2  ))) 


(PWGLdef randomh ( (min "2") (max"200") (rate "1") (mode "0" ) )
"Generates random numbers with a user-defined limit and holds them for a period of time."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 ) ) 
(let* 
( 

(t2 (remove nil (pw::list "randomh:k(" min "," max "," rate
"," mode ")" )) )
)
(values  t2  )))



;;RANDOM

(PWGLdef random1 (  (min "100") (max"1000")   )
"Generates is a controlled pseudo-random number series between min and max values."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 ) ) 
(let* 
( 

(t2 (remove nil (pw::list  "random(" min "," max ")" )) )
)
(values t2  )))


;;JITTER

(PWGLdef jitter ( (kamp "8") (min "15") (max"10")   )
"Generates a segmented line whose segments are randomly generated."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 ) ) 
(let* 
( 
(t2 (remove nil (pw::list  "jitter:k(" kamp "," min "," max ")"  )) )
)
(values t2  )))


;;TRIRAND
(PWGLdef trirand (  (range "100") )
"Triangular distribution random number generator. This is an x-class noise generator."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(t2 (remove nil (pw::list "trirand:k(" range ")" )) )
)
(values t2  )))


;;RANDI
(PWGLdef randi ( (depth "2") (rate "2") )
"randy, generates a controlled random number series with interpolation between each new number.
syntax (a1 rand xamp, xcps)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 ) ) 
(let* 
( 
(t2 (remove nil (pw::list  "randi:k(" depth "," rate ")" )) )
)
(values t2  )))



;;RANDH
(PWGLdef randh ( (depth "100") (rate "10") )
"Generates random numbers and holds them for a period of time."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 ) ) 
(let* 
( 
(t2 (remove nil (pw::list "randh:k(" depth "," rate ")" )) )
)
(values  t2  )))


;;pcauchy
(PWGLdef pcauchy ( (range "1000") )
"Cauchy distribution random number generator (positive values only). This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(t2 (remove nil (pw::list "pcauchy:k(" range ")" )) )
)
(values  t2  )))


;;LINRAND
(PWGLdef linrand (  (range "1000")    )
"Linear distribution random number generator (positive values only). This is an x-class noise generator."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(t2 (remove nil (pw::list  "linrand:k(" range ")"  )) )
)
(values t2  )))


;;seed
(PWGLdef seed (  (range "1000") )
"Sets the global seed value."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(t2 (remove nil (pw::list  "seed" #\Space range   )) )
)
(values t2  )))



;;****************************************
;;****************************************
;;*************OPERATORS******************
;;****************************************
;;****************************************


(PWGLdef add  ( (global "in") )
"+ kenvelope (a1 rand p4+kenv)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1  )) 
(let* 
( 
(mixx1 (remove nil (pw::list  "+" global )))
) 
(values mixx1  )))


(PWGLdef div  ( (global "in") )
"division"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1  )) 
(let* 
( 
(mixx1 (remove nil (pw::list  "/" global )))
) 
(values mixx1  )))


(PWGLdef multiply ( (global "in") )
"* kenvelope (a1 rand p4*kenv)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1  )) 
(let* 
( 
(mixx1 (remove nil (pw::list  "*" global )))
) 
(values mixx1  )))


(PWGLdef add-mult  ( (global1 "in") (global2 "in") )
"+ kenvelope (a1 rand p4+kenv)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2  )) 
(let* 
( 
(mixx1 (remove nil (pw::list  "+" global1 "*" global2 )))
) 
(values mixx1  )))

;;(list (setq newlist (format nil "~{~A~^, ~}"  times )))




;;MIX2
(PWGLdef sum2 (  (in1 ())  (in2 ())   )
"mix 2 input, opcode sum"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "sum(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 




;;balance
(PWGLdef balance (  (in1 ())  (in2 ())   )
"balance"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "balance(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 




;;compress
(PWGLdef compress (  (connect ())  (avoice ()) (kthresh  "0") (kloknee "40") (khiknee  "60") (kratio  "3") (katt  "0.1")  (krel ".5") (ilook "02"))
"Compress, limit, expand, duck or gate an audio signal."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2 2 2  )) 
(let* 
( 
(ad1 (remove nil (pw::list  "compress(" connect "," avoice "," kthresh "," kloknee "," khiknee "," kratio "," katt "," krel "," ilook ")" #\\ #\return )) )
)
(values ad1 ))) 




(PWGLdef gain (  (connect ())  (krms ()) )
"Adjusts the amplitude audio signal according to a root-mean-square value."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 1)) 
(let* 
( 
(ad1 (remove nil (pw::list  "gain(" connect "," krms ")" #\\ #\return )) )
)
(values ad1 ))) 




(PWGLdef  gainslider ( (global "connect") (irange "80" )   )

"An implementation of a logarithmic gain curve which is similar to the gainslider object from Cycling 74 MaxMSP."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list global "*" "gainslider(" irange ")" #\\ #\return )) )) 
(values tone1 ))) 



(PWGLdef  clip ( (global "connect") (imeth "0" ) (ilimit ".5" )  )
"Clips an a-rate signal to a predefined limit, in a soft manner, using one of three methods."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "clip(" global "," imeth "," ilimit ")" #\\ #\return )) )) 
(values tone1 ))) 




(PWGLdef sum3 (  (in1 ())  (in2 ()) (in3 ())  )
"mix 3 input, opcode sum"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 1 1 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "sum(" in1 "," in2 "," in3 ")" #\\ #\return )) )
)
(values ad1 ))) 



(PWGLdef sum4 (  (in1 ())  (in2 ()) (in3 ()) (in4 ())  )
"mix 4 input, opcode sum"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "sum(" in1 "," in2 "," in3  "," in4 ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef sum5 (  (in1 ())  (in2 ()) (in3 ()) (in4 ()) (in5 ()) )
"mix 5 input, opcode sum"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 1 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "sum(" in1 "," in2 "," in3  "," in4 "," in5 ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef sum6 (  (in1 ())  (in2 ()) (in3 ()) (in4 ()) (in5 ()) (in6 ())  )
"mix 6 input, opcode sum"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "sum(" in1 "," in2 "," in3  "," in4 "," in5 "," in6 ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef sum7 (  (in1 ())  (in2 ()) (in3 ()) (in4 ()) (in5 ()) (in6 ()) (in7 ())  )
"mix 7 input, opcode sum"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 1)) 
(let* 
( 
(ad1 (remove nil (pw::list   "sum(" in1 "," in2 "," in3  "," in4 "," in5 "," in6 "," in7 ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef sum8 (  (in1 ())  (in2 ()) (in3 ()) (in4 ()) (in5 ()) (in6 ()) (in7 ())  (in8 ()) )
"mix 8 input, opcode sum"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 2)) 
(let* 
( 
(ad1 (remove nil (pw::list   "sum(" in1 "," in2 "," in3  "," in4 "," in5 "," in6 "," in7 "," in8 ")" #\\ #\return )) )
)
(values ad1 ))) 



(PWGLdef addition (  (in1 ())  (in2 ())   )
"a+b"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "addition(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef subtraction (  (in1 ())  (in2 ())   )
"a-b"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "subtraction(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef multiplication (  (in1 ())  (in2 ())   )
"a*b"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "multiplication(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef division (  (in1 ())  (in2 ())   )
"a/b"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "division(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 


;;VECTORIAL
(PWGLdef vectorial ( (rate "1")  (in1 ())  (in2 ()) (in3 ()) (in4 ())  )
"mix 4 input, vectorial synthesis"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "vectron(" in1 "," in2 "," in3  "," in4 "," rate ")" #\\ #\return )) )
)
(values ad1 ))) 



(PWGLdef vectorial-rt ( (in1 ())  (in2 ()) (in3 ()) (in4 ()) (kx "1") (ky "0") )
"mix 4 input for real time performance, vectorial synthesis"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "vectronrt(" in1 "," in2 "," in3  "," in4 "," kx "," ky ")" #\\ #\return )) )
)
(values ad1 ))) 




(PWGLdef ring (  (in1 ())  (in2 ())   )
"ring modulator (a*b)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "ring(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 

(PWGLdef ring1 (  (in1 ())  (in2 ())   )
"supercollider ugen, ring modulator ((a*b) + a)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "ring1(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 

(PWGLdef ring2 (  (in1 ())  (in2 ())   )
"supercollider ugen, ring modulator  ((a*b) + a + b)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "ring2(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 

(PWGLdef ring3 (  (in1 ())  (in2 ())   )
"supercollider ugen, ring modulator  (a*a *b)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "ring3(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef ring4 (  (in1 ())  (in2 ())   )
"supercollider ugen, ring modulator  ((a*a *b) - (a*b*b))"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "ring4(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef sumsqr (  (in1 ())  (in2 ())   )
"supercollider ugen,(a*a) + (b*b)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "sumsqr(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 ))) 

(PWGLdef difsqr (  (in1 ())  (in2 ())   )
"supercollider ugen, (a*a) - (b*b)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "difsqr(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef sqrsum (  (in1 ())  (in2 ())   )
"supercollider ugen, (a + b)**2"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "sqrsum(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 )))

(PWGLdef sqrdif (  (in1 ())  (in2 ())   )
"supercollider ugen, (a - b)**2"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "sqrdif(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef absdif (  (in1 ())  (in2 ())   )
"supercollider ugen, abs(a - b)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 )) 
(let* 
( 
(ad1 (remove nil (pw::list   "absdif(" in1 "," in2 ")" #\\ #\return )) )
)
(values ad1 )))

;;***********************************

;; Sample level operators

(PWGLdef ntrpol (  (asig1 "0") (asig2 "0") (kpoint "0.5") )
"linear interpolation of two input signals"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "ntrpol:a(" asig1 ","  asig2  ","  kpoint ")" )) )
) 
(values tone1  ))) 




(PWGLdef diff-a (  (asig "0"))
"Modify a signal by differentiation"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "diff:a(" asig ")" )) )
) 
(values tone1  ))) 


(PWGLdef diff-k (  (asig "0"))
"Modify a signal by differentiation"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "diff:k(" asig ")" )) )
) 
(values tone1  ))) 



(PWGLdef downsamp ( (asig "0"))
"Modify a signal by down-sampling."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "downsamp(" asig ")" )) )
) 
(values tone1  )))



(PWGLdef fold ( (asig "0") (kincr "0"))
"Adds artificial foldover to an audio signal"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "fold(" asig ","  kincr ")" )) )
) 
(values tone1  )))



(PWGLdef integ-a ( (asig "0"))
"Modify a signal by integration."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "integ:a(" asig ")" )) )
) 
(values tone1  )))


(PWGLdef integ-k ( (asig "0"))
"Modify a signal by integration."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "integ:k(" asig ")" )) )
) 
(values tone1  )))


(PWGLdef interp ( (ksig "0") (iskip "0") (imode "0") )
"Converts a control signal to an audio signal using linear interpolation"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 1 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "interp(" ksig ","  iskip "," imode ")" )) )
) 
(values tone1  )))




(PWGLdef samphold-a ( (asig "0") (agate "0"))
"Performs a sample-and-hold operation on its input."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "samphold:a(" asig ","  agate  ")" )) )
) 
(values tone1  )))


(PWGLdef samphold-k ( (ksig "0") (kgate "0"))
"Performs a sample-and-hold operation on its input."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "samphold:k(" ksig ","  kgate  ")" )) )
) 
(values tone1  )))


 

(PWGLdef upsamp ( (ksig "0"))
"Modify a signal by up-sampling."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "upsamp(" ksig ")" )) )
) 
(values tone1  )))

;;**************************************

;;*******************************
;;*******************************
;;*********SCORE GENERATOR************
;;*******************************
;;*******************************

;;Make score
(PWGLdef simple-score (  (instr "i1") (p2 "0" ) (p3 "2" ) )
"simple-score"
(:class 'ccl::PWGL-values-box :outputs 1  :r 0.498039 :g 1 :b 0.831373 :w 0.2 :groupings '(1 1 1  ) ) 
(loop for i in (list instr #\Space p2 #\Space p3  #\return) collect i ) )




;;Make score
(PWGLdef Multi-score ( (instr "1") (p2 "0" ) (p3 "2" ) (p4 ".5" ) (p5 "60" ) &optional (p6 () ) (p7 () ) (p8 () ) (p9 () ) (p10 () ) (p11 () ) (p12 () ) (p13 () ) (p14 () ) (p15 () ))
"multi-score"

(:class 'ccl::PWGL-values-box :outputs 1 :r 0.498039 :g 1 :b 0.831373 :w 0.3  :groupings '(1 1 1 1 1 ) ) 
(let* 
             ( 
(ad1 (remove nil (pw::list "i" instr #\Space p2 #\Space p3 #\Space p4 #\Space (pw::m->f  p5  ) #\Space p6 #\Space p7 #\Space 
p8 #\Space p9 #\Space p10 #\Space p11 #\Space p12 #\Space p13 #\Space p14 #\Space p15  #\return )) )

 ) 
 (values ad1   ))) 




(PWGLdef p2-seq ( (N-event 1 ) (base 0  )   (step 1 ) )
"Returns a list of numbers starting from begin to end with increment step, 
add a uniform random function to the list of some depth according to a
value indicated."

(:class 'ccl::PWGL-values-box :outputs 2 :r 0.498039 :g 1 :b 0.831373 :w 0.3 :h 0.25  :groupings '(1 1 1) )

(let* 
( 
(a1 ( pw::loop for i from base to (length N-event) by (+ step 0) collect i))
(a2 ( pw::length N-event))
) 
 (values a1 a2   )))


;; GEN menu
(PWGLdef menu-gen ( (a () (ccl::mk-menu-subview :menu-list 
'(
"gisine"
"gisquare"
"gitri"
"gisaw"
"gibell"
"gipt1" 
"gipt2" 
"gipt3" 
"gipt4" 
"gipt5"
"gipt6" 
"gipt7" 
"gipt8" 


) :value 1))) 
"Gen table menu"
 (:class 'ccl::PWGL-values-box :outputs 1 :r 0.498039 :g 1 :b 0.831373 :w 0.4  :groupings '(1  ) ) 
 (list    a ) )


(PWGLdef menu-grain ( (a () (ccl::mk-menu-subview :menu-list 
'(
"gihamming"
"gibartlett"
"giblackman"
"giBlackHarris"
"gigaussian" 
"girectangle" 
"gisync" 
 
) :value 1))) 
"grain envelope"
 (:class 'ccl::PWGL-values-box :outputs 1 :r 0.498039 :g 1 :b 0.831373 :w 0.5  :groupings '(1  ) ) 
 (list    a ) )




;;sketch
(PWGLdef sketch (  (global "connect")  (dur "2" ) (amp "0.5" ) (freq "60" ) (envelope () ) )
"sketch"
(:class 'ccl::PWGL-values-box :outputs 1 :r 0.498039 :g 1 :b 0.831373 :w 0.4  :groupings '(1 2 2  )) 
(let* 
( 
(mixx1 (remove nil (pw::list 
"<CsoundSynthesizer>" #\return "<CsOptions>" #\return "</CsOptions>" #\return
 "<CsInstruments>" #\return "sr=44100" #\return  "kr=44100" #\return "ksmps=1" #\return  "nchnls" "=" "1" 
 #\return "0dbfs=1" 
#\return #\linefeed "#include"  (concatenate 'string '(#\") "pwcs" '(#\\) "pwcsound.inc" '(#\"))  
#\return #\linefeed 
 "instr" "1" #\return  
#\linefeed "asig" "=" global #\return  #\linefeed "out" "asig"
 envelope #\return #\linefeed "endin" #\return #\linefeed 

"</CsInstruments>" #\return "<CsScore>"   #\return #\linefeed 
 "i1" #\Space "0" #\Space dur #\Space  amp #\Space (pw::m->f  freq  )  #\Space #\return #\linefeed "</CsScore>" #\return "</CsoundSynthesizer>"
 ))) 
           
) 
(values mixx1  ))) 


;;*************

;;sketch
(PWGLdef sketch-midi (  (global "connect")  (dur "3600" )  (envelope () ) )
"midi performance synth"
(:class 'ccl::PWGL-values-box :outputs 1 :r 0.498039 :g 1 :b 0.831373 :w 0.4  :groupings '(1 2   )) 
(let* 
( 
(mixx1 (remove nil (pw::list 
"<CsoundSynthesizer>" #\return "<CsOptions>" #\return "-odac" #\Space "-+rtmidi=virtual" #\Space "-M0" #\return "</CsOptions>" #\return
 "<CsInstruments>" #\return "sr=44100" #\return  "kr=441" #\return "ksmps=100" #\return  "nchnls" "=" "1" 
 #\return "0dbfs=1" 
#\return #\linefeed "#include"  (concatenate 'string '(#\") "pwcs" '(#\\) "pwcsound.inc" '(#\"))  
#\return #\linefeed 
 "instr" "1" #\return  
#\linefeed "asig" "=" global #\return  #\linefeed "out" "asig"
 envelope #\return #\linefeed "endin" #\return #\linefeed 

"</CsInstruments>" #\return "<CsScore>"   #\return #\linefeed 
 "i1" #\Space "0" #\Space dur #\Space   #\return #\linefeed "</CsScore>" #\return "</CsoundSynthesizer>"
 ))) 
           
) 
(values mixx1  ))) 




;;sketch
(PWGLdef sketch-midi2 ( (flag ()) (sr "44100") (ksmps "100") (global "connect")  (dur "3600" )  (envelope () )  )

"real time midi performance, csound flags editor"

(:class 'ccl::PWGL-values-box :outputs 1 :r 0.498039 :g 1 :b 0.831373 :w 0.4  :groupings '(2 2 2 )) 
(let* 
( 
(mixx1 (remove nil (pw::list 
"<CsoundSynthesizer>" #\return "<CsOptions>" #\return flag #\return "</CsOptions>" #\return
 "<CsInstruments>" #\return "sr=" sr #\return  "ksmps=" ksmps #\return  "nchnls" "=" "1" 
 #\return "0dbfs=1" 
#\return #\linefeed "#include"  (concatenate 'string '(#\") "pwcs" '(#\\) "pwcsound.inc" '(#\"))  
#\return #\linefeed 
 "instr" "1" #\return  
#\linefeed "asig" "=" global #\return  #\linefeed "out" "asig"
 envelope #\return #\linefeed "endin" #\return #\linefeed 

"</CsInstruments>" #\return "<CsScore>"   #\return #\linefeed 
 "i1" #\Space "0" #\Space dur #\Space   #\return #\linefeed "</CsScore>" #\return "</CsoundSynthesizer>"
 ))) 
           
) 
(values mixx1  ))) 



;;midi to oscillator
(PWGLdef midisynth ((instr "midi") )

"real time midi performance, ampmidi and cpsmidi opcodes to oscillator"
 
(:class 'ccl::PWGL-values-box :outputs 2 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "ampmidi(1)"


)) )
(ad2 (remove nil (pw::list  "cpsmidi()"
)) )

) 
(values ad1  ad2 )))



(PWGLdef ctrl7 ( (chan "1") (ctlno "1") (min "1") (max "10") )
"Allows a floating-point 7-bit MIDI signal scaled with a minimum and a maximum range."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "ctrl7:k(" chan "," ctlno "," min "," max ")" #\\ #\return )) )
)
(values ad1 ))) 





(PWGLdef  portk ( (global "connect") (ktime ".1" ) )
"Applies portamento to a step-valued control signal."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(2) ) 
(let* 
( (tone1 (remove nil (pw::list "portk(" global "," ktime ")" #\\ #\return )) )) 
(values tone1 ))) 




(PWGLdef gen10 ( (size "16384") (harm ()) )
"Generate composite waveforms made up of weighted sums of simple sinusoids."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "ftgenonce(" "0,0" "," size ",10," (list (setq newlist (format nil "~{~A~^, ~}"  harm ))) ")" #\\ #\return )) )
)
(values ad1 )))



(PWGLdef gen07 ( (size "4097") (harm ()) )
"Constructs functions from segments of straight lines."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "ftgenonce(" "0,0" "," size ",7," (list (setq newlist (format nil "~{~A~^, ~}"  harm ))) ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef gen02 ( (size "4") (values ()) )
"This subroutine transfers data from immediate pfields into a function table."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "ftgenonce(" "0,0" "," size ",2," (list (setq newlist (format nil "~{~A~^, ~}"  values ))) ")" #\\ #\return )) )
)
(values ad1 )))

(PWGLdef gen02-negative ( (size "4") (values ()) )
"This subroutine transfers data from immediate pfields into a function table."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "ftgenonce(" "0,0" "," size ",-2," (list (setq newlist (format nil "~{~A~^, ~}"  values ))) ")" #\\ #\return )) )
)
(values ad1 )))


;;****************************************
;;****************************************
;;*************OSCILLATORS***********************
;;****************************************
;;****************************************


(PWGLdef hiperosc ((kamp ".4")  (kfreq "200") (kdetune "1.2") (ifn "1") (ampdev () ) (freqdev () ) )
"mix 10 oscillators with detune."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 2   ) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "hiperosc(" kamp ampdev  "," kfreq freqdev  "," kdetune "," ifn ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef dualosc ((kamp ".4")  (kfreq "200")  (ifn1 "1") (ifn2 "0.3") (kmorph ".5")  (ampdev () ) (freqdev () ) )
"dual oscillator with morphing."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 2 1  ) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "dualosc(" kamp ampdev  "," kfreq freqdev  "," ifn1 "," ifn2 "," kmorph   ")" #\\ #\return )) )
)
(values ad1 )))



(PWGLdef powershape ( (in1 "connect") (kshape "10") )
"Waveshapes a signal by raising it to a variable exponent."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "powershape(" in1  ","  kshape  ")" )) )
) 
(values tone1  ))) 




(PWGLdef distort ( (in1 "connect") (kdist "1")  (ifn () ) )
"Distort an audio signal via waveshaping and optional clipping."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "distort(" in1  ","  kdist "," ifn  ")" )) )
) 
(values tone1  ))) 



(PWGLdef distort1 ( (in1 "connect") (kpregain "2")  (kpostgain ".5" ) (kshape1 "0") (kshape2 "0")  )
"Modified hyperbolic tangent distortion."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 2 ) ) 
(let* 
( 
(tone1 (remove nil (pw::list "distort1(" in1  ","  kpregain ","  kpostgain ","  kshape1 ","  kshape2  ")" )) )
) 
(values tone1  ))) 



 
(PWGLdef hsboscil ((kamp ".4")  (ktone "1") (kbrite "0.3") (ibasfreq "200") (iwfn "gisine")  (ampdev () ) (freqdev () ) )
"An oscillator which takes tonality and brightness as arguments, relative to a base frequency."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 2 1  ) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "hsboscil(" kamp ampdev  "," ktone  "," kbrite "," ibasfreq freqdev "," iwfn ",giblend"   ")" #\\ #\return )) )
)
(values ad1 )))




(PWGLdef dust ( (iamp ".6") (dens "1000") (ampdev () ) (densdev () ))
"Generates random impulses from 0 to 1."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "dust:a(" iamp ampdev "," dens densdev ")" #\\ #\return )) )
)
(values ad1 )))

(PWGLdef dust2 ( (iamp ".6") (dens "1000") (ampdev () ) (densdev () ))
"Generates random impulses from -1 to 1."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "dust2:a(" iamp ampdev "," dens densdev ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef fractalnoise ( (iamp ".6") (kbeta "0") (ampdev () ) (betadev () ))
"A fractal noise generator implemented as a white noise filtered by a cascade of 15 first-order filters.kbeta = 0 to 2"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "fractalnoise(" iamp ampdev "," kbeta betadev ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef noise ( (iamp ".6") (kbeta "0") (ampdev () ) (betadev () ))
"A white noise generator with an IIR lowpass filter.kbeta = -1 to 1"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "noise(" iamp ampdev "," kbeta betadev ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef saw ( (iamp ".6") (ifreq "220") (ampdev () ) (freqdev () ))
"Vco saw"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "vcosaw(" iamp ampdev "," ifreq freqdev ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef square ( (iamp ".6") (ifreq "220") (kpw ".5") (ampdev () ) (freqdev () ))
"Vco saw"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "vcosquare(" iamp ampdev "," ifreq freqdev "," kpw ")" #\\ #\return )) )
)
(values ad1 )))

;;Phasors


(PWGLdef phasor-a ( (xcps "1") (iphs "0")  (freqdev () ))
"Produce a normalized moving phase value."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "phasor:a(" xcps freqdev "," iphs ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef phasor-k ( (xcps "1") (iphs "0")  (freqdev () ))
"Produce a normalized moving phase value."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "phasor:k(" xcps freqdev "," iphs ")" #\\ #\return )) )
)
(values ad1 )))



(PWGLdef table ( (andx "1") (ifn "0")  (ixmode "0" ) (ixoff "0" ) (iwrap "0" ) )
"Accesses table values by direct indexing."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "table(" andx "," ifn "," ixmode "," ixoff "," iwrap ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef tablei ( (andx "1") (ifn "0")  (ixmode "0" ) (ixoff "0" ) (iwrap "0" ) )
"Accesses table values by direct indexing with linear interpolation."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "tablei(" andx "," ifn "," ixmode "," ixoff "," iwrap ")" #\\ #\return )) )
)
(values ad1 )))



;;BASIC

(PWGLdef sine ( (iamp ".6") (ifreq "220") (ampdev () ) (freqdev () ))
"poscil, High precision oscillator"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "poscil(" iamp ampdev "," ifreq freqdev ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef poscil ( (iamp ".6") (ifreq "220") (ifn "p6") (ampdev () ) (freqdev () ))
"poscil, High precision oscillator"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "poscil(" iamp ampdev "," ifreq freqdev ","  ifn ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef poscil-ph ( (iamp ".6") (ifreq "220") (ifn "p6") (ph ".5") (ampdev () ) (freqdev () ))
"poscil, High precision oscillator"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "poscil(" iamp ampdev "," ifreq freqdev ","  ifn  "," ph ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef poscil-k ( (iamp ".6") (ifreq "220") (ifn "p6") (ph ".5") (ampdev () ) (freqdev () ))
"poscil, High precision oscillator, krate signal"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "poscil:k(" iamp ampdev "," ifreq freqdev ","  ifn  "," ph ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef oscil ( (iamp ".6") (ifreq "220") (ifn "p6") (ampdev () ) (freqdev () ))
"oscil reads table ifn sequentially and repeatedly at a frequency xcps. The amplitude is scaled by xamp"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "oscil(" iamp ampdev "," ifreq freqdev ","  ifn ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef oscil3 ( (iamp ".6") (ifreq "220") (ifn "p6") (ampdev () ) (freqdev () ))
"A simple oscillator with cubic interpolation"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "oscil3(" iamp ampdev "," ifreq freqdev ","  ifn ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef oscili ( (iamp ".6") (ifreq "220") (ifn "p6") (ampdev () ) (freqdev () ))
"A simple oscillator with linear interpolation"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "oscili(" iamp ampdev "," ifreq freqdev ","  ifn ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef poscil3 ( (iamp ".6") (ifreq "220") (ifn "p6") (ampdev () ) (freqdev () ))
"High precision oscillator with cubic interpolation."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "poscil3(" iamp ampdev "," ifreq freqdev ","  ifn ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef buzz ( (iamp ".6") (ifreq "220") (knh "1") (ifn "p6") (ampdev () ) (freqdev () ))
"Output is a set of harmonically related sine partials."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "buzz(" iamp ampdev "," ifreq freqdev "," knh "," ifn ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef gbuzz ( (iamp ".6") (ifreq "220") (knh "1") (klh "1")  (ampdev () ) (freqdev () ))
"Output is a set of harmonically related sine partials."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "gbuzz(" iamp ampdev "," ifreq freqdev "," knh "," klh "," '("0.5,gicosine")  ")" #\\ #\return )) )
)
(values ad1 )))


;;RAND noise
(PWGLdef rand ( (iamp ".6")  (ampdev () ) )
"rand, generates a controlled random number series.
Description : Output is a controlled random number series between -amp and +amp
output  : syntax (a1 rand iamp)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "rand(" iamp ampdev ",rnd(1))" #\\ #\return )) )
)
(values ad1 ))) 



;;FM
(PWGLdef foscili ((iamp ".6") (ifreq "220") (kcar "1") (kmod "2") (kindx "1") (ifn "p6") (ampdev () ) (freqdev () ) )
"Basic frequency modulated oscillator with linear interpolation."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "foscili(" iamp ampdev "," ifreq freqdev "," kcar "," kmod "," kindx "," ifn ")" #\\ #\return )) )
)
(values ad1 ))) 


;Phase Modulation
(PWGLdef phasemod ((iamp ".6")  (kcar "1") (kmod "220") (kindx "1") (kfback ".01")  (ampdev () ) (freqdev () ) )
"phase modulation synthesis"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 2 2  ) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "phasemod(" iamp ampdev  "," kcar freqdev "," kmod "," kindx "," kfback  ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef wterrain ((iamp ".6") (ifreq "220") (kxcenter "1") (kycenter "1") (kxradius "1") (kyradius "1") (itabx ()) (itaby ()) (ampdev () ) (freqdev () ) )
"A simple wave-terrain synthesis opcode"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "wterrain(" iamp ampdev "," ifreq freqdev "," kxcenter "," kycenter "," kxradius "," kyradius "," itabx "," itaby ")" #\\ #\return )) )
)
(values ad1 ))) 


;;IMPULSES
(PWGLdef mpulse ((iamp ".6") (itime ".5") (ampdev () ) (timedev () ))
"Generates a set of impulses of amplitude kamp separated by kintvl seconds (or samples if kintvl is negative)"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list "mpulse(" iamp ampdev "," itime timedev ")" #\\ #\return )) )
)
(values ad1 ))) 



;;PLUCK
(PWGLdef pluck ((iamp ".6") (ifreq "220") (icps "440") (ampdev () ) (freqdev () ))
"pluck, produces a naturally decaying plucked string or drum sound.
Audio output is a naturally decaying plucked string or drum sound based on the Karplus-Strong algorithms."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "pluck(" iamp ampdev "," ifreq freqdev "," icps "," "0" "," "1" ")" #\\ #\return )) )
)
(values ad1 ))) 




(PWGLdef pluck2 ((iamp ".6") (ifreq "220") (icps "440") (ifn "0") (imeth "1") (iparm1 "0") (iparm2 "0") (ampdev () ) (freqdev () ))
"pluck,snare with opzional parameters.
Audio output is a naturally decaying plucked string or drum sound based on the Karplus-Strong algorithms."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "pluck(" iamp ampdev "," ifreq freqdev "," icps "," ifn "," imeth "," iparm1 "," iparm2 ")" #\\ #\return )) )
)
(values ad1 ))) 



(PWGLdef repluck ((iplk "0.75") (iamp ".6") (ifreq "220") (krefl "0.95") (kpick "0.6") (axcite () ) (ampdev () ) (freqdev () ))
"repluck is an implementation of the physical model of the plucked string. A user can control the pluck point, the pickup point, the filter, and an additional audio signal, axcite. axcite is used to excite the 'string'. Based on the Karplus-Strong algorithm."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "repluck(" iplk "," iamp ampdev "," ifreq freqdev "," kpick "," krefl "," axcite ")" #\\ #\return )) )
)
(values ad1 ))) 



(PWGLdef wgbow ( (iamp ".6") (ifreq "220") (kpres "3") (krat "0.23") (kvibf "6.12723" ) (kvamp ".01" )  (ifn "gisine" ) (ampdev () ) )
"Audio output is a tone similar to a bowed string, using a physical model developed from Perry Cook, but re-coded for Csound."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "wgbow("  iamp ampdev "," ifreq  "," kpres "," krat "," kvibf "," kvamp "," ifn ")" #\\ #\return )) )
)
(values ad1 ))) 




(PWGLdef wgbowedbar ( (iamp ".6") (ifreq "220") (kpos "1") (kbowpres ".3") (kgain "0.995" )   (freqdev () ) (ampdev () ) )
"A physical model of a bowed bar, belonging to the Perry Cook family of waveguide instruments"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "wgbowedbar("  iamp ampdev "," ifreq freqdev "," kpos "," kbowpres "," kgain ")" #\\ #\return )) )
)
(values ad1 ))) 




(PWGLdef wgclar ( (iamp ".6") (ifreq "220") (kstiff "-0.3") (iatt "0.1") (idetk "0.1") (kgain "0.2" )  (kvib "5.735" ) (kvamp "0.1")
 (ampdev () ) )
"Audio output is a tone similar to a clarinet, using a physical model developed from Perry Cook, but re-coded for Csound."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.5  :r 0.498039 :g 1 :b 0.831373 :groupings '(3 3 3) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "wgclar("  iamp ampdev "," ifreq  "," kstiff "," iatt "," idetk "," kgain ","
 kvib "," kvamp ",gisine" ")" #\\ #\return )) )
)
(values ad1 ))) 





(PWGLdef wgflute ( (iamp ".6") (ifreq "220") (kjet "0.1") (iatt "0.1") (idetk "0.1") (kgain "0.2" )  (kvib "5.735" ) (kvamp "0.1")
 (ampdev () ) )
"Audio output is a tone similar to a flute, using a physical model developed from Perry Cook, but re-coded for Csound."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.5  :r 0.498039 :g 1 :b 0.831373 :groupings '(3 3 3) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "wgflute("  iamp ampdev "," ifreq  "," kjet "," iatt "," idetk "," kgain ","
 kvib "," kvamp ",gisine" ")" #\\ #\return )) )
)
(values ad1 ))) 



(PWGLdef wgpluck ( (iamp ".6") (ifreq "220") (kpick "0.5") (iplk "0") (idamp "10") (ifilt "1000" ) )
"A high fidelity simulation of a plucked string, using interpolating delay-lines."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.5  :r 0.498039 :g 1 :b 0.831373 :groupings '(3 3) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "wgpluck(" ifreq "," iamp  "," kpick "," iplk "," idamp "," ifilt ",oscili(1,1,gisine)"
  ")" #\\ #\return )) )
)
(values ad1 ))) 





(PWGLdef wgpluck2 ( (kamp ".6") (ifreq "220") (kpick "0.75") (iplk "0.75") (krefl"0.5")  )
"wgpluck2 is an implementation of the physical model of the plucked string, with control over the pluck point, the pickup point and the filter. Based on the Karplus-Strong algorithm."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "wgpluck2(" iplk "," kamp "," ifreq "," kpick "," krefl ")" #\\ #\return )) )
)
(values ad1 )))


;;fm
(PWGLdef fmb3 ((iamp ".6") (ifreq "220") (kc1 "5") (kc2 "5") (depth "0.1" ) (rate "6" ) (ampdev () ) )
"Uses FM synthesis to create a Hammond B3 organ sound.It comes from a family of FM sounds, all using 4 basic oscillators and various architectures, as used in the TX81Z synthesizer."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "fmb3(" iamp ampdev "," ifreq "," kc1 "," kc2 "," depth "," rate  ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef fmbell ((iamp ".6") (ifreq "220") (kc1 "5") (kc2 "5") (depth "0.005" ) (rate "6" ) (ampdev () ) )
"Uses FM synthesis to create a tublar bell sound. It comes from a family of FM sounds, all using 4 basic oscillators and various architectures, as used in the TX81Z synthesizer."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "fmbell(" iamp ampdev "," ifreq "," kc1 "," kc2 "," depth "," rate  ")" #\\ #\return )) )
)
(values ad1 ))) 



(PWGLdef fmpercfl ((iamp ".6") (ifreq "220") (kc1 "5") (kc2 "5") (depth "0.01" ) (rate "6" ) (ampdev () ) )
"Uses FM synthesis to create a percussive flute sound. It comes from a family of FM sounds, all using 4 basic oscillators and various architectures, as used in the TX81Z synthesizer."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "fmpercfl(" iamp ampdev "," ifreq "," kc1 "," kc2 "," depth "," rate  ")" #\\ #\return )) )
)
(values ad1 ))) 



(PWGLdef fmvoice ((iamp ".6") (ifreq "220") (kc1 "5") (kc2 "5") (depth "0.005" ) (rate "6" ) (ampdev () ) )
"FM Singing Voice Synthesis."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "fmvoice(" iamp ampdev "," ifreq "," kc1 "," kc2 "," depth "," rate  ")" #\\ #\return )) )
)
(values ad1 ))) 




;;GENDY
(PWGLdef gendy ((kamp ".6") (kampdist "1") (kdurdist "1") (kadpar "1") (kddpar "1" ) (kminfreq "60" ) (kmaxfreq "2000" ) (kampscl "0.5" ) (kdurscl "0.5" )  (ampdev () ) (freqdev () ))
"Implementation of the Generation Dynamique Stochastique, a dynamic stochastic approach to waveform synthesis conceived by Iannis Xenakis."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "gendy:a(" kamp ampdev "," kampdist "," kdurdist "," kadpar "," kddpar "," kminfreq freqdev "," kmaxfreq 
freqdev "," kampscl "," kdurscl ")" #\\ #\return )) )
)
(values ad1 ))) 


(PWGLdef gendyc ((kamp ".6") (kampdist "1") (kdurdist "1") (kadpar "1") (kddpar "1" ) (kminfreq "60" ) (kmaxfreq "2000" ) (kampscl "0.5" ) (kdurscl "0.5" )  (ampdev () ) (freqdev () ))
"Implementation with cubic interpolation of the Gnration Dynamique Stochastique (GENDYN), a dynamic stochastic approach to waveform synthesis conceived by Iannis Xenakis."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "gendyc:a(" kamp ampdev "," kampdist "," kdurdist "," kadpar "," kddpar "," kminfreq freqdev "," kmaxfreq 
freqdev "," kampscl "," kdurscl ")" #\\ #\return )) )
)
(values ad1 ))) 



(PWGLdef gendyx ((kamp ".6") (kampdist "1") (kdurdist "1") (kadpar "1") (kddpar "1" ) (kminfreq "60" ) (kmaxfreq "2000" ) (kampscl "0.5" ) (kdurscl "0.5" )  (kcurveup "4" ) (kcurvedown "0.5" ) (ampdev () ) (freqdev () ))
"gendyx (gendy eXtended) is an implementation of the Gnration Dynamique Stochastique (GENDYN), a dynamic stochastic approach to waveform synthesis conceived by Iannis Xenakis, using curves instead of segments."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2 2 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "gendyc:a(" kamp ampdev "," kampdist "," kdurdist "," kadpar "," kddpar "," kminfreq freqdev "," kmaxfreq 
freqdev "," kampscl "," kdurscl "," kcurveup "," kcurvedown ")" #\\ #\return )) )
)
(values ad1 )))


;;granular
(PWGLdef diskgrain ((filename () ) (kamp ".5") (timescale ".1") (pitchscale "1")  (ifun () ) )
"diskgrain implements synchronous granular synthesis. The source sound for the grains is obtained by reading a soundfile containing the samples of the source waveform."
(:class 'ccl::PWGL-values-box :outputs 1 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list "diskgrain:a(" (concatenate 'string '(#\") filename '(#\")) "," kamp "," 
"2/0.04" "," pitchscale "," "0.04" "," "1/2*" timescale "," ifun ",2" ")" #\\ #\return )) )
) 
(values ad1   ))) 


;FOF2
(PWGLdef fof ((xamp ".6") (xfund "220") (xform "510")  (kband "30")  (itotdur "p3") (kgliss "1") (ampdev () ) (freqdev () ) )
"Audio output is a succession of sinusoid bursts initiated at frequency xfund with a spectral peak at xform. For xfund above 25 Hz these bursts produce a speech-like formant with spectral characteristics determined by the k-input parameters. For lower fundamentals this generator provides a special form of granular synthesis."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list "fof2(" xamp ampdev "," xfund freqdev"," xform "," "0" "," kband ",0.01,0.03,0.01,100,gisine,gifof2" "," itotdur
",0" "," kgliss  ")" #\\ #\return )) )
)
(values ad1 )))




;;PARTIKKEL
(PWGLdef partikkel ((kamp ".6") (kwavfreq "220") (krate "10") (ksize "1") (krndmask "0") (iwave1 ()) 
(iwave2 ()) (iwave3 ()) (iwave4 ()) (ktransp1 "1") (ktransp2 "1") (ktransp3 "1") (ktransp4 "1") (ampdev () ) (freqdev () ) )
"partikkel was conceived after reading Curtis Roads' book-Microsound, and the goal was to create an opcode that was capable of all time-domain varieties of granular synthesis described in this book. The idea being that most of the techniques only differ in parameter values, and by having a single opcode that can do all varieties of granular synthesis makes it possible to interpolate between techniques. Granular synthesis is sometimes dubbed particle synthesis, and it was thought apt to name the opcode partikkel to distinguish it from other granular opcodes.

Some of the input parameters to partikkel is table numbers, pointing to tables where values for the -per grain- parameter changes are stored. partikkel can use single-cycle or complex (e.g. sampled sound) waveforms as source waveforms for grains. Each grain consists of a mix of 4 source waveforms. Individual tuning of the base frequency can be done for each of the 4 source waveforms. Frequency modulation inside each grain is enabled via an auxillary audio input (awavfm). Trainlet synthesis is available, and trainlets can be mixed with wavetable based grains. Up to 8 separate audio outputs can be used."

(:class 'ccl::PWGL-values-box :outputs 1  :w 0.6  :r 0.498039 :g 1 :b 0.831373 :groupings '(3 4 4 4 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list "microsound(" kamp ampdev "," kwavfreq freqdev "," krate "," ksize "," krndmask
"," '("giattack,gidecay,gicosine") "," iwave1 "," iwave2 "," iwave3 "," iwave4 "," ktransp1 "," ktransp2 "," ktransp3 "," ktransp4                              ")" #\\ #\return )) )
)
(values ad1 ))) 





(PWGLdef grain3 ((kcps "220")  (krand "10") (kgdur "0.3") (kdens "20") (kfn "0") (iwfn "gisine")  (imode "64") (freqdev () ) )
"Generate granular synthesis textures with more user control."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 2 2  ) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "grain3(" kcps freqdev ",0.5," krand ",.05," kgdur "," kdens ",100," kfn "," iwfn ",0,-(randomi:k(0.02,0.5,5)),2,"
imode         ")" #\\ #\return )) )
)
(values ad1 )))





(PWGLdef bamboo ((iamp ".6") (itime "0.01") (ampdev () ) )
"bamboo is a semi-physical model of a bamboo sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "bamboo(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 ))) 



(PWGLdef cabasa ((iamp ".6") (itime "0.01") (ampdev () ) )
"cabasa is a semi-physical model of a cabasa sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "cabasa(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 )))



(PWGLdef crunch ((iamp ".6") (itime "0.01") (ampdev () ) )
"crunch is a semi-physical model of a crunch sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "crunch(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef dripwater ((iamp ".6") (itime "0.01") (ampdev () ) )
"dripwater is a semi-physical model of a dripwater sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "dripwater(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef guiro ((iamp ".6") (itime "0.01") (ampdev () ) )
"guiro is a semi-physical model of a guiro sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "guiro(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef sandpaper ((iamp ".6") (itime "0.01") (ampdev () ) )
"sandpaper is a semi-physical model of a sandpaper sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "sandpaper(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef sekere ((iamp ".6") (itime "0.01") (ampdev () ) )
"sekere is a semi-physical model of a sekere sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "sekere(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 )))



(PWGLdef shaker ((iamp ".6") (itime "0.01") (ampdev () ) )
"shaker is a semi-physical model of a shaker sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "shaker(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 )))



(PWGLdef stix ((iamp ".6") (itime "0.01") (ampdev () ) )
"stix is a semi-physical model of a stix sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "stix(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 )))



(PWGLdef sleighbells ((iamp ".6") (itime "0.01") (ampdev () ) )
"sleighbells is a semi-physical model of a sleighbells sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "sleighbells(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 )))


(PWGLdef tambourine ((iamp ".6") (itime "0.01") (ampdev () ) )
"tambourine is a semi-physical model of a tambourine sound. It is one of the PhISEM percussion opcodes. PhISEM (Physically Informed Stochastic Event Modeling) is an algorithmic approach for simulating collisions of multiple independent sound producing objects"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '(2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "tambourine(" iamp ampdev "," itime  ")" #\\ #\return )) )
)
(values ad1 )))






;;SCANNED

(PWGLdef simple-scan ( (iamp ".6") (ifreq "110") (irate ".5") (ampdev () ) (freqdev () ))
"Scanned synthesis"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '( 1 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "scanned(" iamp ampdev "," ifreq freqdev "," irate "," '("gitraj,giinit,givel,gimass,gispring,giforce,gidamp") ")" #\\ #\return )) )
)
(values ad1 )))



(PWGLdef scan-injection ( (iamp ".6") (ifreq "110") (irate ".5") (ain ()) (ampdev () ) (freqdev () ))
"Scanned synthesis"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3  :r 0.498039 :g 1 :b 0.831373 :groupings '( 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list   "scanned2(" iamp ampdev "," ifreq freqdev "," irate "," '("gitraj,giinit,givel,gimass,gispring,giforce,gidamp,") ain ")" #\\ #\return )) )
)
(values ad1 )))

;;****************************************
;;*************SAMPLING***********************
;;****************************************


(PWGLdef soundin ((filename () )  )
"simple sampler"
 (:class 'ccl::PWGL-values-box :outputs 1 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 ) ) 
(let* 
( 
(ad1 (remove nil (pw::list "soundin:a(" (concatenate 'string '(#\") filename '(#\"))
")" #\\ #\return )) )
) 
(values ad1   ))) 


;;diskin2
(PWGLdef diskin2-noloop ((filename () ) (kpitch "1") (pitchdev ()) )
"Reads audio data from a file, and can alter its pitch using one of several available interpolation types, as well as convert the sample rate to match the orchestra sr setting."
 (:class 'ccl::PWGL-values-box :outputs 1 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 1 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "diskin2:a(" (concatenate 'string '(#\") filename '(#\")) "," kpitch pitchdev '(",0,0,0,32")
")" #\\ #\return )) )
) 
(values ad1   )))


;;diskin2-hd
(PWGLdef diskin2-hd ((filename () ) (kpitch "1") (pitchdev ()) )
"diskin2 high quality for best precision in transpositions"
 (:class 'ccl::PWGL-values-box :outputs 1 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 1 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "diskin2:a(" (concatenate 'string '(#\") filename '(#\")) "," kpitch pitchdev '(",0,1,8,512,262144,0")
")" #\\ #\return )) )
) 
(values ad1   ))) 

;;diskin2
(PWGLdef diskin2 ((filename () ) (kpitch "1") (pitchdev ()) )
"Reads audio data from a file, and can alter its pitch using one of several available interpolation types, as well as convert the sample rate to match the orchestra sr setting."
 (:class 'ccl::PWGL-values-box :outputs 1 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 1 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "diskin2:a(" (concatenate 'string '(#\") filename '(#\")) "," kpitch pitchdev '(",0,1,0,32")
")" #\\ #\return )) )
) 
(values ad1   )))



(PWGLdef loscil3 ((kamp ".6") (kpitch "1") (filename () ) (basenote "261.626") (loop "0") (ampdev ()) (pitchdev ()) )
"Read sampled sound from a table using cubic interpolation."
 (:class 'ccl::PWGL-values-box :outputs 1 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 1) ) 
(let* 
( 
(ad1 (remove nil (pw::list "loscil3:a(" kamp ampdev "," kpitch pitchdev  "," '("ftgenonce(0,0,0,1,") (concatenate 'string '(#\") filename '(#\")) '(",0,0,1)") "," basenote "," loop ")" #\\ #\return )) )
) 
(values ad1   ))) 



(PWGLdef flooper ((kamp ".6") (kpitch "1") (istart "0") (idur "1") (ifad "0.05") (filename () )  (ampdev ()) (pitchdev ()) )
"This opcode reads audio from a function table and plays it back in a loop with user-defined start time, duration and crossfade time. It also allows the pitch of the loop to be controlled, including reversed playback. It accepts non-power-of-two tables, such as deferred-allocation GEN01 tables"
 (:class 'ccl::PWGL-values-box :outputs 1 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list "flooper(" kamp ampdev "," kpitch pitchdev "," istart "," idur "," ifad "," '("ftgenonce(0,0,0,1,") (concatenate 'string '(#\") filename '(#\")) '(",0,0,1)")
")" #\\ #\return )) )
) 
(values ad1   ))) 


(PWGLdef flooper2 ((kamp ".6") (kpitch "1") (kstart "0") (kend "1") (kfad "0.05") (filename () )  (ampdev ()) (pitchdev ()) )
"This opcode implements a crossfading looper with variable loop parameters and three looping modes, optionally using a table for its crossfade shape. It accepts non-power-of-two tables for its source sounds, such as deferred-allocation GEN01 tables"
 (:class 'ccl::PWGL-values-box :outputs 1 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list "flooper2(" kamp ampdev "," kpitch pitchdev "," kstart "," kend "," kfad "," '("ftgenonce(0,0,0,1,") (concatenate 'string '(#\") filename '(#\")) '(",0,0,1)")
")" #\\ #\return )) )
) 
(values ad1   ))) 



(PWGLdef bbcutm ((asource ()) (ibps "4") (isubdiv "8") (ibarlength "4") (iphrasebars "1") (inumrepeats "2" )  )
"The BreakBeat Cutter automatically generates cut-ups of a source audio stream in the style of drum and bass/jungle breakbeat manipulations. There are two versions, for mono (bbcutm) or stereo (bbcuts) sources. Whilst originally based on breakbeat cutting, the opcode can be applied to any type of source audio"
 (:class 'ccl::PWGL-values-box :outputs 1 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(2 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list "bbcutm("  asource "," ibps "," isubdiv "," ibarlength "," iphrasebars "," inumrepeats ")" #\\ #\return )) )
) 
(values ad1   ))) 




;;****************************************
;;*************SEQUENCER***********************
;;****************************************

;; Possibile bug con schedwhen!!!!!!

(PWGLdef schedkwhen( (ktrigger "1") (kmintim "0") (kmaxnum "1") (kinsnum "2") (kwhen "0")  (kdur ".5")  (p4 "1") (p5 "220") )
"Adds a new score event generated by a k-rate trigger."
(:class 'ccl::PWGL-values-box :outputs 2  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2 2 2 ) ) 
(let* 
( (tone1 (remove nil (pw::list "schedkwhen(" ktrigger "," kmintim "," kmaxnum "," kinsnum "," kwhen "," kdur "," p4 ","  p5  ")" #\return )) ) 
(tone2 (remove nil (pw::list  kinsnum )) )
) 
(values tone1 tone2 )))


(PWGLdef metro( (value "1")  )
"Generate a metronomic signal to be used in any circumstance an isochronous trigger is needed."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1  ) ) 
(let* 
( (tone1 (remove nil (pw::list "metro(" value  ")"  )) )) 
(values tone1 )))



;;sequencer
(PWGLdef sequencer ((instr "1") (times 1 ) (p4 "0.5" ) (pitches "60" )  (insnum "2" ) )

"step-sequencer"
 
(:class 'ccl::PWGL-values-box :outputs 2 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "instr" instr #\return
'("imap ftgenonce 0,0,1024,-2,") (list (setq newlist (format nil "~{~A~^, ~}"  times ))) #\return
'("inote ftgenonce 0,0 ,1024 ,-2 ,") (list (setq newlist (format nil "~{~A~^, ~}"  (pw::m->f  pitches  ) ))) #\return
'("ktrig	seqtime2 0, 1, 0, 1000, 2, imap") #\return
'("kfreq random 0,") (length pitches ) #\return
'("kpitch table kfreq,inote")  #\return
'("schedkwhen ktrig, 0, 0,") insnum  '(", 0, ktrig,") p4  '(", kpitch") #\return
"endin" #\return

)) )
(ad2 (remove nil (pw::list  insnum
)) )

) 
(values ad1  ad2 )))



;;sequencer
(PWGLdef chord ((instr "1") (times 1 ) (p4 "0.5" ) (pitches "60" )  (insnum "2" ) )

"4 voice chord sequencer"
 
(:class 'ccl::PWGL-values-box :outputs 2 :w 0.3 :r 0.498039 :g 1 :b 0.831373 :groupings '(1 2 2) ) 
(let* 
( 
(ad1 (remove nil (pw::list  "instr" instr #\return
'("imap ftgenonce 0,0,1024,-2,") (list (setq newlist (format nil "~{~A~^, ~}"  times ))) #\return
'("inote ftgenonce 0,0 ,1024 ,-2 ,") (list (setq newlist (format nil "~{~A~^, ~}"  (pw::m->f  pitches  ) ))) #\return
'("ktrig	seqtime2 0, 1, 0, 1000, 2, imap") #\return
'("kfreq1 random 0,") (length pitches ) #\return
'("kfreq2 random 0,") (length pitches ) #\return
'("kfreq3 random 0,") (length pitches ) #\return
'("kfreq4 random 0,") (length pitches ) #\return
'("kpitch1 table kfreq1,inote")  #\return
'("kpitch2 table kfreq2,inote")  #\return
'("kpitch3 table kfreq3,inote")  #\return
'("kpitch4 table kfreq4,inote")  #\return
'("schedkwhen ktrig, 0, 0,") insnum  '(", 0, ktrig,") p4 "*.4" '(", kpitch1") #\return
'("schedkwhen ktrig, 0, 0,") insnum  '(", 0, ktrig,") p4 "*.4" '(", kpitch2") #\return
'("schedkwhen ktrig, 0, 0,") insnum  '(", 0, ktrig,") p4 "*.4" '(", kpitch3") #\return
'("schedkwhen ktrig, 0, 0,") insnum  '(", 0, ktrig,") p4 "*.4" '(", kpitch4") #\return

"endin" #\return

)) )
(ad2 (remove nil (pw::list  insnum
)) )

) 
(values ad1  ad2 )))


;;****************************************
;;*************SPECTRAL***********************
;;****************************************
	


(PWGLdef  timestretch ( (ktime "1" ) (kamp "1" ) (kpitch "1" ) (filename () ) )
"temposcal opcode,Phase-locked vocoder processing with onset detection/processing."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2 ) ) 
(let* 
( (tone1 (remove nil (pw::list "temposcal:a(" ktime "," kamp "," kpitch ","
'("ftgenonce(0, 0, 0, 1,") (concatenate 'string '(#\") filename '(#\")) '(", 0, 0, 1)") ",0"
 ")" #\\ #\return )) )) 
(values tone1 )))




(PWGLdef  analysis ( (global "ain") (fftsize "16384" ) (winshape "1" )  )
"pvsanal - generate an fsig from a mono audio source ain, using phase vocoder overlap-add analysis."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvsanal(" global "," fftsize  "," fftsize '("/4") "," fftsize  "," winshape ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  resynthesis ( (global "connect")  )
"Resynthesise phase vocoder data (f-signal) using a FFT overlap-add."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvsynth(" global  ")" #\\ #\return )) )) 
(values tone1 ))) 

;;fsig pvsfreeze fsigin, kfreeza, kfreezf


(PWGLdef  pvsfreeze ( (global "connect") (kfreeza ".5" ) (kfreezf "1" )  )
"pvsfreeze  Freeze the amplitude and frequency time functions of a pv stream according to a control-rate trigger."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvsfreeze(" global "," kfreeza "," kfreezf ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  pvswarp ( (global "connect") (kscal "1" ) (kshift "0" )  )
"Warp the spectral envelope of a PVS signal by means of shifting and scaling."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvswarp(" global "," kscal "," kshift ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  pvscale ( (global "connect") (kscal "2" )   )
"Scale the frequency components of a pv stream, resulting in pitch shift. Output amplitudes can be optionally modified in order to attempt formant preservation."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvscale(" global "," kscal  ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  pvsmix ( (ain1 "in1") (ain2 "in2" )   )
"Mix 'seamlessly' two pv signals. This opcode combines the most prominent components of two pvoc streams into a single mixed stream."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvsmix(" ain1 "," ain2  ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  pvsmooth ( (global "connect") (kacf ".01" ) (kfcf ".01" )  )
"Smooth the amplitude and frequency time functions of a pv stream using parallel 1st order lowpass IIR filters with time-varying cutoff frequency."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvsmooth(" global "," kacf "," kfcf ")" #\\ #\return )) )) 
(values tone1 ))) 



(PWGLdef  pvsfilter ( (ain1 "in1") (ain2 "in2" )  (kdepth "0.5" ))
"Multiply amplitudes of a pvoc stream by those of a second pvoc stream, with dynamic scaling."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvsfilter(" ain1 "," ain2 "," kdepth ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  pvsblur ( (global "connect") (ktime ".5" ) (idel ".9" )  )
"Average the amp-freq time functions of each analysis channel for a specified time (truncated to number of frames). As a side-effect the input pvoc stream will be delayed by that amount."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvsblur(" global "," ktime "," idel ")" #\\ #\return )) )) 
(values tone1 ))) 




(PWGLdef  pvsmorph ( (ain1 "in1") (ain2 "in2" )  (kampint "0.5" ) (kfrqint "0.5" ) )
"Performs morphing (or interpolation) between two source fsigs."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 1 1 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvsmorph(" ain1 "," ain2 "," kampint "," kfrqint ")" #\\ #\return )) )) 
(values tone1 ))) 



(PWGLdef  pvsarp ( (ain "in")   (kbin "0.1" ) (kdepth "0.9" ) (kgain "2" ) )
"This opcode arpeggiates spectral components, by amplifying one bin and attenuating all the others around it. Used with an LFO it will provide a spectral arpeggiator similar to Trevor Wishart's CDP program specarp."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvsarp(" ain "," kbin "," kdepth "," kgain ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  pvsvoc ( (ain1 "in1")  (ain2 "in2") (kdepth "1" ) (kgain "1" ) )
"This opcode provides support for cross-synthesis of amplitudes and frequencies. It takes the amplitudes of one input fsig and combines with frequencies from another. It is a spectral version of the well-known channel vocoder"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2 ) ) 
(let* 
( (tone1 (remove nil (pw::list "pvsvoc(" ain1 "," ain2 "," kdepth "," kgain ")" #\\ #\return )) )) 
(values tone1 ))) 

;;****************************************
;;****************************************
;;*************RESONATORS****************
;;****************************************
;;****************************************

(PWGLdef  streson ( (global "connect") (kfr "440" ) (ifdbgain "0.9" ) ( freqdev () ) )
"An audio signal is modified by a string resonator with variable fundamental frequency."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "streson(" global "," kfr  freqdev "," ifdbgain ")" #\\ #\return )) )) 
(values tone1 ))) 

(PWGLdef  wguide1 ( (global "connect") (kfr "440" ) (kcutoff "1000" ) (kfeedback ".8" ) ( freqdev () ))
"A simple waveguide model consisting of one delay-line and one first-order lowpass filter."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '(1 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "wguide1(" global "," kfr  freqdev "," kcutoff freqdev "," kfeedback ")" #\\ #\return )) )) 
(values tone1 ))) 



(PWGLdef  wguide2 ( (global "connect") (kfr1 "220" ) (kfr2 "440" ) (kcutoff1 "10000" ) (kcutoff2 "5000" ) (kfeedback1 ".2" ) (kfeedback2 ".2" ) ( freqdev () ) )
"A model of beaten plate consisting of two parallel delay-lines and two first-order lowpass filters."
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.4 :r 0.498039 :g 1 :b 0.831373  :groupings '(2 2 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "wguide2(" global "," kfr1  freqdev "," kfr2  freqdev "," kcutoff1 freqdev "," kcutoff2 freqdev  "," kfeedback1 "," kfeedback2 ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  mode ( (global "connect") (kfr "440" ) (kq "1000" )  ( freqdev () ))
"Filters the incoming signal with the specified resonance frequency and quality factor. It can also be seen as a signal generator for high quality factor, with an impulse for the excitation. You can combine several modes to built complex instruments such as bells or guitar tables"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "mode(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 ))) 



(PWGLdef  membrane ( (global "connect") (kfr "440" ) (kq "1000" )  ( freqdev () ))
"Membrane"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "membrane(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  chime_tube2 ( (global "connect") (kfr "440" ) (kq "1000" )  ( freqdev () ))
"chime_tube2"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "chime_tube2(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  jegogan_bars ( (global "connect") (kfr "240" ) (kq "100" )  ( freqdev () ))
"jegogan_bars"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "jegogan_bars(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  aluminum_bar ( (global "connect") (kfr "240" ) (kq "100" )  ( freqdev () ))
"aluminum_bar"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "aluminum_bar(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  redwood ( (global "connect") (kfr "240" ) (kq "100" )  ( freqdev () ))
"redwood"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "redwood(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 ))) 


(PWGLdef  dahina_tabla ( (global "connect") (kfr "240" ) (kq "100" )  ( freqdev () ))
"dahina_tabla"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "dahina_tabla(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 )))

(PWGLdef  vibraphone1 ( (global "connect") (kfr "240" ) (kq "100" )  ( freqdev () ))
"vibraphone1"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "vibraphone1(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 )))

(PWGLdef  wine_glass ( (global "connect") (kfr "240" ) (kq "100" )  ( freqdev () ))
"wine_glass"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "wine_glass(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 )))
  

(PWGLdef  spinel_sphere ( (global "connect") (kfr "240" ) (kq "100" )  ( freqdev () ))
"spinel_sphere"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "spinel_sphere(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 )))

(PWGLdef  small_handbell ( (global "connect") (kfr "240" ) (kq "100" )  ( freqdev () ))
"small_handbell"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "small_handbell(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 )))

(PWGLdef  tibetan_bowl ( (global "connect") (kfr "240" ) (kq "100" )  ( freqdev () ))
"tibetan_bowl"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "tibetan_bowl(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 )))

(PWGLdef  pot_lit ( (global "connect") (kfr "240" ) (kq "100" )  ( freqdev () ))
"pot_lit"
(:class 'ccl::PWGL-values-box :outputs 1  :w 0.3 :r 0.498039 :g 1 :b 0.831373  :groupings '( 2 2  ) ) 
(let* 
( (tone1 (remove nil (pw::list "pot_lit(" global "," kfr  freqdev "," kq  ")" #\\ #\return )) )) 
(values tone1 )))

 
